//------------------------------------------------------------------+
//
//------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DarkSlateGray
#property indicator_color2 DarkSlateGray
#property indicator_color3 DarkSlateGray
#property indicator_color4 PaleVioletRed
#property indicator_width4 2
#property indicator_style1 STYLE_DOT
#property indicator_style5 STYLE_DOT

//
//
//
//
//

extern int    HLRPeriod   =  40;
extern int    maPeriod    =  20;
extern int    maMethod    =   1;
extern int    maPrice     =   0;
extern int    overBought  =  80;
extern int    overSold    =  20;
extern string TimeFrame   = "Current time frame";
extern bool   interpolate = true;

//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
int    timeFrame;
int    atrTimeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);

   //
   //
   //
   //
   //
   
   timeFrame = stringToTimeFrame(TimeFrame);
   atrTimeFrame=PERIOD_D1;
   if (timeFrame >= atrTimeFrame)
      switch (timeFrame)
         {
            case PERIOD_D1: atrTimeFrame = PERIOD_W1; break;
            default:        atrTimeFrame = PERIOD_MN1;
         }
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMax(MathMin(Bars-counted_bars,Bars-1),timeFrame/Period());   
      
   //
   //
   //
   //
   //
   
      for (int i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame   ,Time[i]);
         int r = iBarShift(NULL,atrTimeFrame,Time[i]);
            double avgRange = iATR(NULL,atrTimeFrame,maPeriod,r);
            double maValue  = iMA(NULL,timeFrame,maPeriod,0,maMethod,maPrice,y);
            
            double hhv  = iHigh(NULL,timeFrame,iHighest(NULL,timeFrame, MODE_HIGH, HLRPeriod, y));
            double llv  = iLow(NULL, timeFrame,iLowest (NULL,timeFrame, MODE_LOW,  HLRPeriod, y)); 
            double m_pr = (iHigh(NULL,timeFrame,y) + iLow(NULL,timeFrame,y)) / 2.0; 
            double hlr  = (m_pr - llv) / (hhv - llv); 
               
            //
            //
            //
            //
            //
               
            ExtMapBuffer1[i] = maValue;
            ExtMapBuffer2[i] = maValue+(avgRange*(overBought-50.0)/100.0);
            ExtMapBuffer3[i] = maValue-(avgRange*(50.0-  overSold)/100.0);
            ExtMapBuffer4[i] = maValue+(hlr-0.5)*avgRange;
               
            //
            //
            //
            //
            //
               
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!interpolate) continue;
        
            //    
            //
            //
            //
            //

            datetime	time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
              double factor = 1.0 / n;
              for(int k = 1; k < n; k++)
              {
                 ExtMapBuffer1[i+k] = k*factor*ExtMapBuffer1[i+n] + (1.0-k*factor)*ExtMapBuffer1[i];
                 ExtMapBuffer2[i+k] = k*factor*ExtMapBuffer2[i+n] + (1.0-k*factor)*ExtMapBuffer2[i];
                 ExtMapBuffer3[i+k] = k*factor*ExtMapBuffer3[i+n] + (1.0-k*factor)*ExtMapBuffer3[i];
                 ExtMapBuffer4[i+k] = k*factor*ExtMapBuffer4[i+n] + (1.0-k*factor)*ExtMapBuffer4[i];
              }             
         }
   
   //
   //
   //
   //
   //
         
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}